;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Yoshi Coin Fix, by imamelia
;;
;; This patch fixes two glitches with the Yoshi coin:
;;
;; 1) You can now place the coins on subscreen boundaries.
;; 2) You can now make Map16 tiles on other pages act like the Yoshi coin tiles.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

header
lorom

!Freespace = $168000

org $00F332
CPY #$2D
BCC $31
PHY
JSL $00F377
INC $1422
LDA $1422
CMP #$05
BCC $0B
PHX
JSR $F3B2
ORA $1F2F,y
STA $1F2F,y
PLX
LDA #$1C
STA $1DF9
LDA #$01
JSL $05B330
LDA #$01
STA $9C
JSL $00BEB0
JML NewGen


org !Freespace

db "STAR"
dw EndCode-StartCode-$01
dw EndCode-StartCode-$01^$FFFF

StartCode:

NewGen:
LDA #$01
STA $9C
JSL $00BEB0
PLY
REP #$20
LDA $98
CPY #$2D
BNE NotTopTile
CLC
ADC.w #$0010
BRA SetY
NotTopTile:
SEC
SBC.w #$0010
SetY:
STA $98
SEP #$20
LDA #$01
STA $9C
JSL $00BEB0
JML $00F373

EndCode:

print "Freespace used: ",bytes," bytes."
