;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Sting
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!FreeRam = $0F6A
!SpriteNumber = $05

print "INIT ",pc
RTL

print "MAIN ",pc
PHB
PHK
PLB
JSR Code
PLB
RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Code:
JSR Graphics ;jusr debug
LDA $9D
BNE Return
JSR Pointers
Return:
RTS

Pointers:
LDA $C2,x
JSL $0086DF
dw DoRandom
dw S
RTS
S:
LDA $151C,x
JSL $0086DF
dw Dia
dw Spawn
RTS
DoRandom:
	JSL Random
	LDA !FreeRam
	EOR $7B
	EOR $7D
	AND #$01
STA $151C,x
INC $C2,x
RTS

Spawn:
JSR Ax
JSR B
JSR C
JSR D
STZ $14C8,x
RTS

Dia:
JSR Axx
JSR Bx
JSR Cx
JSR Dx
STZ $14C8,x
RTS

Ax:
	LDA $186C,x
	BNE .EndSpawn
	JSL $02A9DE
	BMI .EndSpawn
	LDA #$01				; Sprite state ($14C8,x).
	STA $14C8,y
	PHX
	TYX
	LDA #!SpriteNumber	; This the sprite number to spawn.
	STA $7FAB9E,x
	PLX
	LDA $E4,x
	STA $00E4,y
	LDA $14E0,x
	STA $14E0,y
	LDA $D8,x
	STA $00D8,y
	LDA $14D4,x
	STA $14D4,y
	PHX
	TYX
	JSL $07F7D2
	JSL $0187A7
	LDA #$08
	STA $7FAB10,x
	PLX
	LDA #$02
	STA $00C2,y
.EndSpawn
	RTS
B:
	LDA $186C,x
	BNE .EndSpawn
	JSL $02A9DE
	BMI .EndSpawn
	LDA #$01				; Sprite state ($14C8,x).
	STA $14C8,y
	PHX
	TYX
	LDA #!SpriteNumber	; This the sprite number to spawn.
	STA $7FAB9E,x
	PLX
	LDA $E4,x
	STA $00E4,y
	LDA $14E0,x
	STA $14E0,y
	LDA $D8,x
	STA $00D8,y
	LDA $14D4,x
	STA $14D4,y
	PHX
	TYX
	JSL $07F7D2
	JSL $0187A7
	LDA #$08
	STA $7FAB10,x
	PLX
	LDA #$01
	STA $00C2,y
.EndSpawn
	RTS
C:
	LDA $186C,x
	BNE .EndSpawn
	JSL $02A9DE
	BMI .EndSpawn
	LDA #$01				; Sprite state ($14C8,x).
	STA $14C8,y
	PHX
	TYX
	LDA #!SpriteNumber	; This the sprite number to spawn.
	STA $7FAB9E,x
	PLX
	LDA $E4,x
	STA $00E4,y
	LDA $14E0,x
	STA $14E0,y
	LDA $D8,x
	STA $00D8,y
	LDA $14D4,x
	STA $14D4,y
	PHX
	TYX
	JSL $07F7D2
	JSL $0187A7
	LDA #$08
	STA $7FAB10,x
	PLX
	LDA #$00
	STA $00C2,y
.EndSpawn
	RTS
D:
	LDA $186C,x
	BNE .EndSpawn
	JSL $02A9DE
	BMI .EndSpawn
	LDA #$01				; Sprite state ($14C8,x).
	STA $14C8,y
	PHX
	TYX
	LDA #!SpriteNumber	; This the sprite number to spawn.
	STA $7FAB9E,x
	PLX
	LDA $E4,x
	STA $00E4,y
	LDA $14E0,x
	STA $14E0,y
	LDA $D8,x
	STA $00D8,y
	LDA $14D4,x
	STA $14D4,y
	PHX
	TYX
	JSL $07F7D2
	JSL $0187A7
	LDA #$08
	STA $7FAB10,x
	PLX
	LDA #$03
	STA $00C2,y
.EndSpawn
	RTS

Axx:
	LDA $186C,x
	BNE .EndSpawn
	JSL $02A9DE
	BMI .EndSpawn
	LDA #$01				; Sprite state ($14C8,x).
	STA $14C8,y
	PHX
	TYX
	LDA #!SpriteNumber	; This the sprite number to spawn.
	STA $7FAB9E,x
	PLX
	LDA $E4,x
	STA $00E4,y
	LDA $14E0,x
	STA $14E0,y
	LDA $D8,x
	STA $00D8,y
	LDA $14D4,x
	STA $14D4,y
	PHX
	TYX
	JSL $07F7D2
	JSL $0187A7
	LDA #$08
	STA $7FAB10,x
	PLX
	LDA #$04
	STA $00C2,y
.EndSpawn
	RTS
Bx:
	LDA $186C,x
	BNE .EndSpawn
	JSL $02A9DE
	BMI .EndSpawn
	LDA #$01				; Sprite state ($14C8,x).
	STA $14C8,y
	PHX
	TYX
	LDA #!SpriteNumber	; This the sprite number to spawn.
	STA $7FAB9E,x
	PLX
	LDA $E4,x
	STA $00E4,y
	LDA $14E0,x
	STA $14E0,y
	LDA $D8,x
	STA $00D8,y
	LDA $14D4,x
	STA $14D4,y
	PHX
	TYX
	JSL $07F7D2
	JSL $0187A7
	LDA #$08
	STA $7FAB10,x
	PLX
	LDA #$05
	STA $00C2,y
.EndSpawn
	RTS
Cx:
	LDA $186C,x
	BNE .EndSpawn
	JSL $02A9DE
	BMI .EndSpawn
	LDA #$01				; Sprite state ($14C8,x).
	STA $14C8,y
	PHX
	TYX
	LDA #!SpriteNumber	; This the sprite number to spawn.
	STA $7FAB9E,x
	PLX
	LDA $E4,x
	STA $00E4,y
	LDA $14E0,x
	STA $14E0,y
	LDA $D8,x
	STA $00D8,y
	LDA $14D4,x
	STA $14D4,y
	PHX
	TYX
	JSL $07F7D2
	JSL $0187A7
	LDA #$08
	STA $7FAB10,x
	PLX
	LDA #$06
	STA $00C2,y
.EndSpawn
	RTS
Dx:
	LDA $186C,x
	BNE .EndSpawn
	JSL $02A9DE
	BMI .EndSpawn
	LDA #$01				; Sprite state ($14C8,x).
	STA $14C8,y
	PHX
	TYX
	LDA #!SpriteNumber	; This the sprite number to spawn.
	STA $7FAB9E,x
	PLX
	LDA $E4,x
	STA $00E4,y
	LDA $14E0,x
	STA $14E0,y
	LDA $D8,x
	STA $00D8,y
	LDA $14D4,x
	STA $14D4,y
	PHX
	TYX
	JSL $07F7D2
	JSL $0187A7
	LDA #$08
	STA $7FAB10,x
	PLX
	LDA #$07
	STA $00C2,y
.EndSpawn
	RTS

Random:
	LDA !FreeRam
	BNE Next
	LDA #$FF
	EOR $7B
	EOR $7D
	EOR $0F36
	STA !FreeRam
Next:  LDA !FreeRam
 ASL A
 EOR !FreeRam
 ASL A
 EOR !FreeRam
 ASL A
 ASL A
 EOR !FreeRam
 BPL Null
Eins: LDA !FreeRam
 ASL A
 ORA #$01
 STA !FreeRam
 RTL
Null: LDA !FreeRam
 ASL A
 STA !FreeRam
 RTL

Graphics:
	JSR GET_DRAW_INFO
	PHX
	LDX #$00
Loop:
	LDA $00
	STA $0300,y
	
	LDA $01
	STA $0301,y
	
	LDA #$C0
	STA $0302,y
	
	LDA #$0F
	STA $0303,y
	
	INY
	INY
	INY
	INY
	DEX
	BPL Loop
	PLX
	
	LDY #$02
	LDA #$00
	JSL $01B7B3
	RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPR_T1:              
db $0C,$1C
SPR_T2:             
db $01,$02

GET_DRAW_INFO:       
	STZ $186C,x           
	STZ $15A0,x             
	LDA $E4,x               
	CMP $1A                 
	LDA $14E0,x             
	SBC $1B                 
	BEQ ON_SCREEN_X         
	INC $15A0,x             

ON_SCREEN_X:         
	LDA $14E0,x             
	XBA	 
	LDA $E4,x               
	REP #$20                
	SEC	
	SBC $1A                 
	CLC	
	ADC #$0040            
	CMP #$0180            ;  | IF YOU READ THIS, YOU WIN A COOKIE! PM ME AND I'LL GIVE YOU A FREE ASM HACK WOOHOO!
	SEP #$20                ;  |
	ROL A                   ;  |
	AND #$01                ;  |
	STA $15C4,x             ; / 
	BNE INVALID             ; 
	
	LDY #$00                ; \ set up loop:
	LDA $1662,x             ;  | 
	AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
	BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
	INY	 ; / 
ON_SCREEN_LOOP:      LDA $D8,x               ; \ 
	CLC	 ;  | set vertical offscreen if necessary
	ADC SPR_T1,y            ;  |
	PHP	 ;  |
	CMP $1C                 ;  | (vert screen boundry)
	ROL $00                 ;  |
	PLP	 ;  |
	LDA $14D4,x             ;  | 
	ADC #$00                ;  |
	LSR $00                 ;  |
	SBC $1D                 ;  |
	BEQ ON_SCREEN_Y         ;  |
	LDA $186C,x             ;  | (vert offscreen)
	ORA SPR_T2,y            ;  |
	STA $186C,x             ;  |
ON_SCREEN_Y:         DEY	 ;  |
	BPL ON_SCREEN_LOOP      ; /

	LDY $15EA,x             ; get offset to sprite OAM
	LDA $E4,x               ; \ 
	SEC	 ;  | 
	SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
	STA $00                 ; / 
	LDA $D8,x               ; \ 
	SEC	 ;  | 
	SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
	STA $01                 ; / 
	RTS	 ; return

INVALID:             PLA	 ; \ return from *main gfx routine* subroutine...
	PLA	 ;  |    ...(not just this subroutine)
	RTS	 ; /